# coding: utf-8

"""
    Bitbucket API

    Code against the Bitbucket API to automate simple tasks, embed Bitbucket data into your own site, build mobile or desktop apps, or even add custom UI add-ons into Bitbucket itself using the Connect framework.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@bitbucket.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class BaseCommitAllOfSummary(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'html': 'str',
        'markup': 'str',
        'raw': 'str'
    }

    attribute_map = {
        'html': 'html',
        'markup': 'markup',
        'raw': 'raw'
    }

    def __init__(self, html=None, markup=None, raw=None):  # noqa: E501
        """BaseCommitAllOfSummary - a model defined in OpenAPI"""  # noqa: E501

        self._html = None
        self._markup = None
        self._raw = None
        self.discriminator = None

        if html is not None:
            self.html = html
        if markup is not None:
            self.markup = markup
        if raw is not None:
            self.raw = raw

    @property
    def html(self):
        """Gets the html of this BaseCommitAllOfSummary.  # noqa: E501

        The user's content rendered as HTML.  # noqa: E501

        :return: The html of this BaseCommitAllOfSummary.  # noqa: E501
        :rtype: str
        """
        return self._html

    @html.setter
    def html(self, html):
        """Sets the html of this BaseCommitAllOfSummary.

        The user's content rendered as HTML.  # noqa: E501

        :param html: The html of this BaseCommitAllOfSummary.  # noqa: E501
        :type: str
        """

        self._html = html

    @property
    def markup(self):
        """Gets the markup of this BaseCommitAllOfSummary.  # noqa: E501

        The type of markup language the raw content is to be interpreted in.  # noqa: E501

        :return: The markup of this BaseCommitAllOfSummary.  # noqa: E501
        :rtype: str
        """
        return self._markup

    @markup.setter
    def markup(self, markup):
        """Sets the markup of this BaseCommitAllOfSummary.

        The type of markup language the raw content is to be interpreted in.  # noqa: E501

        :param markup: The markup of this BaseCommitAllOfSummary.  # noqa: E501
        :type: str
        """
        allowed_values = ["markdown", "creole", "plaintext"]  # noqa: E501
        if markup not in allowed_values:
            raise ValueError(
                "Invalid value for `markup` ({0}), must be one of {1}"  # noqa: E501
                .format(markup, allowed_values)
            )

        self._markup = markup

    @property
    def raw(self):
        """Gets the raw of this BaseCommitAllOfSummary.  # noqa: E501

        The text as it was typed by a user.  # noqa: E501

        :return: The raw of this BaseCommitAllOfSummary.  # noqa: E501
        :rtype: str
        """
        return self._raw

    @raw.setter
    def raw(self, raw):
        """Sets the raw of this BaseCommitAllOfSummary.

        The text as it was typed by a user.  # noqa: E501

        :param raw: The raw of this BaseCommitAllOfSummary.  # noqa: E501
        :type: str
        """

        self._raw = raw

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BaseCommitAllOfSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
