# coding: utf-8

"""
    Bitbucket API

    Code against the Bitbucket API to automate simple tasks, embed Bitbucket data into your own site, build mobile or desktop apps, or even add custom UI add-ons into Bitbucket itself using the Connect framework.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@bitbucket.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class DeploymentRelease(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'commit': 'Commit',
        'created_on': 'datetime',
        'name': 'str',
        'url': 'str',
        'uuid': 'str'
    }

    attribute_map = {
        'commit': 'commit',
        'created_on': 'created_on',
        'name': 'name',
        'url': 'url',
        'uuid': 'uuid'
    }

    def __init__(self, commit=None, created_on=None, name=None, url=None, uuid=None):  # noqa: E501
        """DeploymentRelease - a model defined in OpenAPI"""  # noqa: E501

        self._commit = None
        self._created_on = None
        self._name = None
        self._url = None
        self._uuid = None
        self.discriminator = None

        if commit is not None:
            self.commit = commit
        if created_on is not None:
            self.created_on = created_on
        if name is not None:
            self.name = name
        if url is not None:
            self.url = url
        if uuid is not None:
            self.uuid = uuid

    @property
    def commit(self):
        """Gets the commit of this DeploymentRelease.  # noqa: E501


        :return: The commit of this DeploymentRelease.  # noqa: E501
        :rtype: Commit
        """
        return self._commit

    @commit.setter
    def commit(self, commit):
        """Sets the commit of this DeploymentRelease.


        :param commit: The commit of this DeploymentRelease.  # noqa: E501
        :type: Commit
        """

        self._commit = commit

    @property
    def created_on(self):
        """Gets the created_on of this DeploymentRelease.  # noqa: E501

        The timestamp when the release was created.  # noqa: E501

        :return: The created_on of this DeploymentRelease.  # noqa: E501
        :rtype: datetime
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this DeploymentRelease.

        The timestamp when the release was created.  # noqa: E501

        :param created_on: The created_on of this DeploymentRelease.  # noqa: E501
        :type: datetime
        """

        self._created_on = created_on

    @property
    def name(self):
        """Gets the name of this DeploymentRelease.  # noqa: E501

        The name of the release.  # noqa: E501

        :return: The name of this DeploymentRelease.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeploymentRelease.

        The name of the release.  # noqa: E501

        :param name: The name of this DeploymentRelease.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def url(self):
        """Gets the url of this DeploymentRelease.  # noqa: E501

        Link to the pipeline that produced the release.  # noqa: E501

        :return: The url of this DeploymentRelease.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this DeploymentRelease.

        Link to the pipeline that produced the release.  # noqa: E501

        :param url: The url of this DeploymentRelease.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def uuid(self):
        """Gets the uuid of this DeploymentRelease.  # noqa: E501

        The UUID identifying the release.  # noqa: E501

        :return: The uuid of this DeploymentRelease.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this DeploymentRelease.

        The UUID identifying the release.  # noqa: E501

        :param uuid: The uuid of this DeploymentRelease.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeploymentRelease):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
