# coding: utf-8

"""
    Bitbucket API

    Code against the Bitbucket API to automate simple tasks, embed Bitbucket data into your own site, build mobile or desktop apps, or even add custom UI add-ons into Bitbucket itself using the Connect framework.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@bitbucket.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class PipelineRefTarget(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'commit': 'Commit',
        'ref_name': 'str',
        'ref_type': 'str',
        'selector': 'PipelineSelector'
    }

    attribute_map = {
        'type': 'type',
        'commit': 'commit',
        'ref_name': 'ref_name',
        'ref_type': 'ref_type',
        'selector': 'selector'
    }

    def __init__(self, type=None, commit=None, ref_name=None, ref_type=None, selector=None):  # noqa: E501
        """PipelineRefTarget - a model defined in OpenAPI"""  # noqa: E501

        self._type = None
        self._commit = None
        self._ref_name = None
        self._ref_type = None
        self._selector = None
        self.discriminator = None

        self.type = type
        if commit is not None:
            self.commit = commit
        if ref_name is not None:
            self.ref_name = ref_name
        if ref_type is not None:
            self.ref_type = ref_type
        if selector is not None:
            self.selector = selector

    @property
    def type(self):
        """Gets the type of this PipelineRefTarget.  # noqa: E501


        :return: The type of this PipelineRefTarget.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this PipelineRefTarget.


        :param type: The type of this PipelineRefTarget.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def commit(self):
        """Gets the commit of this PipelineRefTarget.  # noqa: E501


        :return: The commit of this PipelineRefTarget.  # noqa: E501
        :rtype: Commit
        """
        return self._commit

    @commit.setter
    def commit(self, commit):
        """Sets the commit of this PipelineRefTarget.


        :param commit: The commit of this PipelineRefTarget.  # noqa: E501
        :type: Commit
        """

        self._commit = commit

    @property
    def ref_name(self):
        """Gets the ref_name of this PipelineRefTarget.  # noqa: E501

        The name of the reference.  # noqa: E501

        :return: The ref_name of this PipelineRefTarget.  # noqa: E501
        :rtype: str
        """
        return self._ref_name

    @ref_name.setter
    def ref_name(self, ref_name):
        """Sets the ref_name of this PipelineRefTarget.

        The name of the reference.  # noqa: E501

        :param ref_name: The ref_name of this PipelineRefTarget.  # noqa: E501
        :type: str
        """

        self._ref_name = ref_name

    @property
    def ref_type(self):
        """Gets the ref_type of this PipelineRefTarget.  # noqa: E501

        The type of reference (branch/tag).  # noqa: E501

        :return: The ref_type of this PipelineRefTarget.  # noqa: E501
        :rtype: str
        """
        return self._ref_type

    @ref_type.setter
    def ref_type(self, ref_type):
        """Sets the ref_type of this PipelineRefTarget.

        The type of reference (branch/tag).  # noqa: E501

        :param ref_type: The ref_type of this PipelineRefTarget.  # noqa: E501
        :type: str
        """
        allowed_values = ["branch", "tag", "named_branch", "bookmark"]  # noqa: E501
        if ref_type not in allowed_values:
            raise ValueError(
                "Invalid value for `ref_type` ({0}), must be one of {1}"  # noqa: E501
                .format(ref_type, allowed_values)
            )

        self._ref_type = ref_type

    @property
    def selector(self):
        """Gets the selector of this PipelineRefTarget.  # noqa: E501


        :return: The selector of this PipelineRefTarget.  # noqa: E501
        :rtype: PipelineSelector
        """
        return self._selector

    @selector.setter
    def selector(self, selector):
        """Sets the selector of this PipelineRefTarget.


        :param selector: The selector of this PipelineRefTarget.  # noqa: E501
        :type: PipelineSelector
        """

        self._selector = selector

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PipelineRefTarget):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
