# coding: utf-8

"""
    Bitbucket API

    Code against the Bitbucket API to automate simple tasks, embed Bitbucket data into your own site, build mobile or desktop apps, or even add custom UI add-ons into Bitbucket itself using the Connect framework.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@bitbucket.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class SshKey(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'comment': 'str',
        'created_on': 'datetime',
        'key': 'str',
        'label': 'str',
        'last_used': 'datetime',
        'links': 'BranchingModelSettingsAllOfLinks',
        'uuid': 'str'
    }

    attribute_map = {
        'comment': 'comment',
        'created_on': 'created_on',
        'key': 'key',
        'label': 'label',
        'last_used': 'last_used',
        'links': 'links',
        'uuid': 'uuid'
    }

    def __init__(self, comment=None, created_on=None, key=None, label=None, last_used=None, links=None, uuid=None):  # noqa: E501
        """SshKey - a model defined in OpenAPI"""  # noqa: E501

        self._comment = None
        self._created_on = None
        self._key = None
        self._label = None
        self._last_used = None
        self._links = None
        self._uuid = None
        self.discriminator = None

        if comment is not None:
            self.comment = comment
        if created_on is not None:
            self.created_on = created_on
        if key is not None:
            self.key = key
        if label is not None:
            self.label = label
        if last_used is not None:
            self.last_used = last_used
        if links is not None:
            self.links = links
        if uuid is not None:
            self.uuid = uuid

    @property
    def comment(self):
        """Gets the comment of this SshKey.  # noqa: E501

        The comment parsed from the SSH key (if present)  # noqa: E501

        :return: The comment of this SshKey.  # noqa: E501
        :rtype: str
        """
        return self._comment

    @comment.setter
    def comment(self, comment):
        """Sets the comment of this SshKey.

        The comment parsed from the SSH key (if present)  # noqa: E501

        :param comment: The comment of this SshKey.  # noqa: E501
        :type: str
        """

        self._comment = comment

    @property
    def created_on(self):
        """Gets the created_on of this SshKey.  # noqa: E501


        :return: The created_on of this SshKey.  # noqa: E501
        :rtype: datetime
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this SshKey.


        :param created_on: The created_on of this SshKey.  # noqa: E501
        :type: datetime
        """

        self._created_on = created_on

    @property
    def key(self):
        """Gets the key of this SshKey.  # noqa: E501

        The SSH public key value in OpenSSH format.  # noqa: E501

        :return: The key of this SshKey.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this SshKey.

        The SSH public key value in OpenSSH format.  # noqa: E501

        :param key: The key of this SshKey.  # noqa: E501
        :type: str
        """

        self._key = key

    @property
    def label(self):
        """Gets the label of this SshKey.  # noqa: E501

        The user-defined label for the SSH key  # noqa: E501

        :return: The label of this SshKey.  # noqa: E501
        :rtype: str
        """
        return self._label

    @label.setter
    def label(self, label):
        """Sets the label of this SshKey.

        The user-defined label for the SSH key  # noqa: E501

        :param label: The label of this SshKey.  # noqa: E501
        :type: str
        """

        self._label = label

    @property
    def last_used(self):
        """Gets the last_used of this SshKey.  # noqa: E501


        :return: The last_used of this SshKey.  # noqa: E501
        :rtype: datetime
        """
        return self._last_used

    @last_used.setter
    def last_used(self, last_used):
        """Sets the last_used of this SshKey.


        :param last_used: The last_used of this SshKey.  # noqa: E501
        :type: datetime
        """

        self._last_used = last_used

    @property
    def links(self):
        """Gets the links of this SshKey.  # noqa: E501


        :return: The links of this SshKey.  # noqa: E501
        :rtype: BranchingModelSettingsAllOfLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this SshKey.


        :param links: The links of this SshKey.  # noqa: E501
        :type: BranchingModelSettingsAllOfLinks
        """

        self._links = links

    @property
    def uuid(self):
        """Gets the uuid of this SshKey.  # noqa: E501

        The SSH key's immutable ID.  # noqa: E501

        :return: The uuid of this SshKey.  # noqa: E501
        :rtype: str
        """
        return self._uuid

    @uuid.setter
    def uuid(self, uuid):
        """Sets the uuid of this SshKey.

        The SSH key's immutable ID.  # noqa: E501

        :param uuid: The uuid of this SshKey.  # noqa: E501
        :type: str
        """

        self._uuid = uuid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SshKey):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
