# coding: utf-8

"""
    Bitbucket API

    Code against the Bitbucket API to automate simple tasks, embed Bitbucket data into your own site, build mobile or desktop apps, or even add custom UI add-ons into Bitbucket itself using the Connect framework.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@bitbucket.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class Tag(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'RefLinks',
        'name': 'str',
        'target': 'Commit',
        'type': 'str',
        'date': 'datetime',
        'message': 'str',
        'tagger': 'Author'
    }

    attribute_map = {
        'links': 'links',
        'name': 'name',
        'target': 'target',
        'type': 'type',
        'date': 'date',
        'message': 'message',
        'tagger': 'tagger'
    }

    def __init__(self, links=None, name=None, target=None, type=None, date=None, message=None, tagger=None):  # noqa: E501
        """Tag - a model defined in OpenAPI"""  # noqa: E501

        self._links = None
        self._name = None
        self._target = None
        self._type = None
        self._date = None
        self._message = None
        self._tagger = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if name is not None:
            self.name = name
        if target is not None:
            self.target = target
        self.type = type
        if date is not None:
            self.date = date
        if message is not None:
            self.message = message
        if tagger is not None:
            self.tagger = tagger

    @property
    def links(self):
        """Gets the links of this Tag.  # noqa: E501


        :return: The links of this Tag.  # noqa: E501
        :rtype: RefLinks
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this Tag.


        :param links: The links of this Tag.  # noqa: E501
        :type: RefLinks
        """

        self._links = links

    @property
    def name(self):
        """Gets the name of this Tag.  # noqa: E501

        The name of the ref.  # noqa: E501

        :return: The name of this Tag.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Tag.

        The name of the ref.  # noqa: E501

        :param name: The name of this Tag.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def target(self):
        """Gets the target of this Tag.  # noqa: E501


        :return: The target of this Tag.  # noqa: E501
        :rtype: Commit
        """
        return self._target

    @target.setter
    def target(self, target):
        """Sets the target of this Tag.


        :param target: The target of this Tag.  # noqa: E501
        :type: Commit
        """

        self._target = target

    @property
    def type(self):
        """Gets the type of this Tag.  # noqa: E501


        :return: The type of this Tag.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Tag.


        :param type: The type of this Tag.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def date(self):
        """Gets the date of this Tag.  # noqa: E501

        The date that the tag was created, if available  # noqa: E501

        :return: The date of this Tag.  # noqa: E501
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """Sets the date of this Tag.

        The date that the tag was created, if available  # noqa: E501

        :param date: The date of this Tag.  # noqa: E501
        :type: datetime
        """

        self._date = date

    @property
    def message(self):
        """Gets the message of this Tag.  # noqa: E501

        The message associated with the tag, if available.  # noqa: E501

        :return: The message of this Tag.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this Tag.

        The message associated with the tag, if available.  # noqa: E501

        :param message: The message of this Tag.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def tagger(self):
        """Gets the tagger of this Tag.  # noqa: E501


        :return: The tagger of this Tag.  # noqa: E501
        :rtype: Author
        """
        return self._tagger

    @tagger.setter
    def tagger(self, tagger):
        """Sets the tagger of this Tag.


        :param tagger: The tagger of this Tag.  # noqa: E501
        :type: Author
        """

        self._tagger = tagger

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Tag):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
