# coding: utf-8

"""
    Bitbucket API

    Code against the Bitbucket API to automate simple tasks, embed Bitbucket data into your own site, build mobile or desktop apps, or even add custom UI add-ons into Bitbucket itself using the Connect framework.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@bitbucket.org
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class TeamPermission(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'permission': 'str',
        'team': 'Team',
        'type': 'str',
        'user': 'User'
    }

    attribute_map = {
        'permission': 'permission',
        'team': 'team',
        'type': 'type',
        'user': 'user'
    }

    def __init__(self, permission=None, team=None, type=None, user=None):  # noqa: E501
        """TeamPermission - a model defined in OpenAPI"""  # noqa: E501

        self._permission = None
        self._team = None
        self._type = None
        self._user = None
        self.discriminator = None

        if permission is not None:
            self.permission = permission
        if team is not None:
            self.team = team
        self.type = type
        if user is not None:
            self.user = user

    @property
    def permission(self):
        """Gets the permission of this TeamPermission.  # noqa: E501


        :return: The permission of this TeamPermission.  # noqa: E501
        :rtype: str
        """
        return self._permission

    @permission.setter
    def permission(self, permission):
        """Sets the permission of this TeamPermission.


        :param permission: The permission of this TeamPermission.  # noqa: E501
        :type: str
        """
        allowed_values = ["admin", "collaborator"]  # noqa: E501
        if permission not in allowed_values:
            raise ValueError(
                "Invalid value for `permission` ({0}), must be one of {1}"  # noqa: E501
                .format(permission, allowed_values)
            )

        self._permission = permission

    @property
    def team(self):
        """Gets the team of this TeamPermission.  # noqa: E501


        :return: The team of this TeamPermission.  # noqa: E501
        :rtype: Team
        """
        return self._team

    @team.setter
    def team(self, team):
        """Sets the team of this TeamPermission.


        :param team: The team of this TeamPermission.  # noqa: E501
        :type: Team
        """

        self._team = team

    @property
    def type(self):
        """Gets the type of this TeamPermission.  # noqa: E501


        :return: The type of this TeamPermission.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this TeamPermission.


        :param type: The type of this TeamPermission.  # noqa: E501
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def user(self):
        """Gets the user of this TeamPermission.  # noqa: E501


        :return: The user of this TeamPermission.  # noqa: E501
        :rtype: User
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this TeamPermission.


        :param user: The user of this TeamPermission.  # noqa: E501
        :type: User
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TeamPermission):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
